
#ifndef  WIPPE_H
#define WIPPE_H WIPPE_H
#include <math.h>
// #include "Roboter.h"
// #include "Spieler.h"
// #include "BewGewicht.h"


#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif


/// \brief Wippe.
///
/// Die Wippe enth�lt Zeiger auf einen Spieler und einen
/// Roboter sowie Methoden zur Durchf�hrung der
/// Simulation.


class BewGewicht;

class Wippe{
	private:
		/// erlaubte Position auf der Wippe
		float m_fPosMin, m_fPosMax;
		/// L�nge in m
		float laenge;
		/// Auslenkung (rad)
		float phi;
		/// maximale Auslenkung (rad)
		const float phiMax; //(40.*M_PI/180.);
		/// Erdbeschleunigung in (kg m) / (s * s)
		const float g;// = 9.81;
		/// Winkelgeschwindigkeit, Winkelbeschleunigung
		float omega, omega_punkt;
		/// Roboter
		BewGewicht *rob;
		/// Spieler
		BewGewicht *spiel;
		/// Berechne Tr�gheitsmoment
		float traegheitsmoment() const;
		/// Berechne Drehmoment
		float drehmoment() const;

	public:
		void init();
		float getPhi() const { return phi; } 
		float getOmega() const { return omega; }
		float getOmega_Punkt() const { return omega_punkt; }
		float getLaenge() const { return laenge; }
		float getRoboterPosition() const;
		float getRoboterMasse() const;
		float getSpielerPosition() const;
		float getSpielerMasse() const;
		bool sicherheitsBereichUeberschritten(){ return (fabs(phi) > phiMax); }
		void simulationsSchritt(float deltaT);
		Wippe(float l, BewGewicht *r, BewGewicht *p);
	
};
#endif
